package com.allyourcode.p03_03_13;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class MySaxHandler extends DefaultHandler {

  private static final String CONDITION = "weather";
  private static final String TEMP_F = "temp_f";

  private Weather weather = new Weather();

  private boolean isInTemp_f = false;
  private boolean isInCondition = false;


  public Weather getWeather() {
    return weather;
  }

  @Override
  public void startElement(String namespaceURI,
                           String localName,
                           String qName,
                           Attributes attributes)
                                  throws SAXException {
    if (localName.equals(TEMP_F)) {
      isInTemp_f = true;
    } else if (localName.equals(CONDITION)) {
      isInCondition = true;
    }
  }

  @Override
  public void characters(char[] ch,
                         int start,
                         int length) {
    if (isInTemp_f) {
      weather.temperature =
                         new String(ch, start, length);
    } else if (isInCondition) {
      weather.condition = new String(ch, start, length);
    }
  }

  @Override
  public void endElement(String namespaceURI,
                         String localName,
                         String qName)
                                  throws SAXException {
    if (localName.equals(TEMP_F)) {
      isInTemp_f = false;
    } else if (localName.equals(CONDITION)) {
      isInCondition = false;
    }
  }
}
