package com.allyourcode.dynamiclayout;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;

public class MainActivity extends Activity
   implements View.OnClickListener {
  LinearLayout rootlayout;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    rootlayout =
       (LinearLayout) findViewById(R.id.linear_layout);
    Button firstButton = (Button) findViewById(R.id.button);
    firstButton.setOnClickListener(this);
  }

  @Override
  public void onClick(View view) {
    LayoutParams editTextLayoutParams =
       new LayoutParams(LayoutParams.WRAP_CONTENT,
          LayoutParams.WRAP_CONTENT);
    LayoutParams buttonLayoutParams =
       new LayoutParams(LayoutParams.WRAP_CONTENT,
          LayoutParams.WRAP_CONTENT);
    LayoutParams rowLayoutParams =
       new LayoutParams(LayoutParams.MATCH_PARENT,
          LayoutParams.WRAP_CONTENT);

    EditText editText = new EditText(this);
    editText.setLayoutParams(editTextLayoutParams);
    editText.setHint(R.string.type_text_here);

    Button button = new Button(this);
    button.setLayoutParams(buttonLayoutParams);
    button.setText(R.string.add_a_row);
    button.setOnClickListener(this);

    LinearLayout newRow = new LinearLayout(this);
    newRow.setLayoutParams(rowLayoutParams);
    newRow.setOrientation(LinearLayout.HORIZONTAL);

    newRow.addView(editText);
    newRow.addView(button);

    LinearLayout currentRow =
       ((LinearLayout) view.getParent());
    int currentIndex =
       ((LinearLayout) currentRow.getParent())
          .indexOfChild(currentRow);
    rootlayout.addView(newRow, currentIndex + 1);
  }

}
