package com.allmycode.menus;

import android.app.Activity;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.ActionMode;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.AbsListView.MultiChoiceModeListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.util.ArrayList;


public class MyMenusActivity extends Activity {
  ListView listView;

  ArrayList<String> listItems = new ArrayList<String>();
  ArrayAdapter<String> adapter;

  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);

    listView = (ListView) findViewById(R.id.listView1);
    adapter = new ArrayAdapter<String>
       (this, R.layout.my_list_layout, listItems);
    listView.setAdapter(adapter);
    listView.setChoiceMode
       (ListView.CHOICE_MODE_MULTIPLE_MODAL);

    listView.
       setMultiChoiceModeListener(new MultiChoiceModeListener() {
         int positionOfLongPressedItem;

         @Override
         public boolean onActionItemClicked
            (ActionMode mode, MenuItem item) {
           switch (item.getItemId()) {

        case R.id.menu_delete:
          deleteReminder(positionOfLongPressedItem);
          mode.finish();

               break;
             case R.id.make_noise2:
               MediaPlayer mediaPlayer = MediaPlayer.create
                  (MyMenusActivity.this, R.raw.quack);
               mediaPlayer.start();
               break;
           }
           return true;
         }

         @Override
         public boolean onCreateActionMode
            (ActionMode mode, Menu menu) {
           MenuInflater inflater = mode.getMenuInflater();
           inflater.inflate
              (R.menu.list_menu_item_longpress, menu);
           return true;
         }

         @Override
         public void onItemCheckedStateChanged
            (ActionMode mode, int position,
             long id, boolean checked)   {
           positionOfLongPressedItem = position;
         }

         @Override
         public void onDestroyActionMode(ActionMode mode) {
         }

         @Override
         public boolean onPrepareActionMode
            (ActionMode mode, Menu menu) {
           return false;
         }
       });
  }

  void deleteReminder(int  positionOfLongPressedItem) {
    listItems.remove(positionOfLongPressedItem);
    adapter.notifyDataSetChanged();
  }


  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    super.onCreateOptionsMenu(menu);

    MenuInflater inflater = getMenuInflater();
    inflater.inflate(R.menu.list_menu, menu);
    return true;
  }

  @Override
  public boolean onOptionsItemSelected(MenuItem item) {

    switch (item.getItemId()) {

      case R.id.menu_insert:
        createReminder();
        return true;

      case R.id.make_noise:
        MediaPlayer mediaPlayer =
           MediaPlayer.create(this, R.raw.honk);
        mediaPlayer.start();
        return true;

    }
    return super.onOptionsItemSelected(item);
  }

  private static final int ACTIVITY_CREATE = 0;

  private void createReminder() {
    Intent intent =
       new Intent(this, ReminderEditActivity.class);
    startActivityForResult(intent, ACTIVITY_CREATE);
  }

  @Override
  protected void onActivityResult(int requestCode,
                                  int resultCode, Intent intent) {
    if (resultCode == RESULT_OK) {
      listItems.add(intent
         .getStringExtra("reminder_text"));
      adapter.notifyDataSetChanged();
    }
  }

}