package com.allmycode.frag;

import android.app.Fragment;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

public class DocsFragment extends Fragment
                          implements OnClickListener {
  TextView textView1;

  @Override
  public View onCreateView(LayoutInflater inflater,
                           ViewGroup container,
                           Bundle savedInstanceState) {

    return myLayout();
  }

  @Override
  public void onClick(View view) {
    int index = getArguments().getInt("index");

    //Create fragment with index
    DocsFragmentVerbose docsFragmentVerbose =
                           new DocsFragmentVerbose();
    Bundle args = Helper.getBundleWithIndex(index);
    docsFragmentVerbose.setArguments(args);

    //Perform the transaction
    FragmentTransaction fragmentTransaction =
             getFragmentManager().beginTransaction();
    fragmentTransaction.replace(R.id.docs,
                                docsFragmentVerbose);
    fragmentTransaction.addToBackStack(null);
    fragmentTransaction.commit();
  }

  final static int[] DOCS = {
      R.string.doc_activity,
      R.string.doc_service,
      R.string.doc_broadcast_receiver,
      R.string.content_provider
  };

  private LinearLayout myLayout() {

    LinearLayout layout = new LinearLayout(getActivity());
    layout.setOrientation(LinearLayout.VERTICAL);

    int index = getArguments().getInt("index");

    textView1 = new TextView(getActivity());
    textView1.setTextSize(30);
    textView1
        .setText(ComponentNamesFragment.COMPONENTS[index]);
    layout.addView(textView1);
    TextView textView2 = new TextView(getActivity());
    textView2.setTextSize(20);
    textView2.setText(DOCS[index]);
    layout.addView(textView2);

    Button button = new Button(getActivity());
    button.setText(R.string.more);
    button.setOnClickListener(this);
    layout.addView(button);

    return layout;
  }
}
