package com.allmycode.catalogbrowser;

import android.app.Activity;
import android.app.FragmentManager;
import android.os.Bundle;
import android.support.v17.leanback.app.BrowseFragment;
import android.support.v17.leanback.widget.ArrayObjectAdapter;
import android.support.v17.leanback.widget.HeaderItem;
import android.support.v17.leanback.widget.ListRow;
import android.support.v17.leanback.widget.ListRowPresenter;

public class BrowseMediaActivity extends Activity {

  protected BrowseFragment mBrowseFragment;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.browse_fragment);

    final FragmentManager fragmentManager = getFragmentManager();
    mBrowseFragment = (BrowseFragment) fragmentManager.findFragmentById(
        R.id.browse_fragment);

    mBrowseFragment.setHeadersState(BrowseFragment.HEADERS_ENABLED);
    mBrowseFragment.setTitle(getString(R.string.app_name));
    mBrowseFragment.setBadgeDrawable(getResources().getDrawable(
        R.drawable.ic_launcher));

    buildRowsAdapter();
  }

  private ArrayObjectAdapter mRowsAdapter;
  private static final int NUM_ROWS = 4;

  private void buildRowsAdapter() {
    mRowsAdapter = new ArrayObjectAdapter(new ListRowPresenter());

    for (int i = 0; i < NUM_ROWS; ++i) {
      ArrayObjectAdapter listRowAdapter = new ArrayObjectAdapter(
          new CardPresenter());
      listRowAdapter.add("Media Item " + i + ".1");
      listRowAdapter.add("Media Item " + i + ".2");
      listRowAdapter.add("Media Item " + i + ".3");
      HeaderItem header = new HeaderItem(i, "Category " + i);
      mRowsAdapter.add(new ListRow(header, listRowAdapter));
    }

    mBrowseFragment.setAdapter(mRowsAdapter);
  }
}