package com.allmycode.catalogbrowser;

import android.content.Context;
import android.support.v17.leanback.widget.ImageCardView;
import android.support.v17.leanback.widget.Presenter;
import android.view.View;
import android.view.ViewGroup;

public class CardPresenter extends Presenter {

  private static Context mContext;
  private static int CARD_WIDTH = 313;
  private static int CARD_HEIGHT = 176;

  static class ViewHolder extends Presenter.ViewHolder {
    private ImageCardView mCardView;

    public ViewHolder(View view) {
      super(view);
      mCardView = (ImageCardView) view;
    }
  }

  @Override
  public ViewHolder onCreateViewHolder(ViewGroup parent) {
    mContext = parent.getContext();
    ImageCardView cardView = new ImageCardView(mContext);
    cardView.setFocusable(true);
    cardView.setFocusableInTouchMode(true);
    return new ViewHolder(cardView);
  }

  @Override
  public void onBindViewHolder(Presenter.ViewHolder viewHolder, Object item) {
    ((ViewHolder) viewHolder).mCardView.setTitleText((String) item);
    ((ViewHolder) viewHolder).mCardView.setMainImageDimensions(CARD_WIDTH, CARD_HEIGHT);
    ((ViewHolder) viewHolder).mCardView.setMainImage(mContext.getResources().getDrawable(R.drawable.movie_poster, null));
  }

  @Override
  public void onUnbindViewHolder(Presenter.ViewHolder viewHolder) {
  }
}